#!/usr/bin/python

###############################
# Original Code from this site:
# http://www.sunspot.co.uk/Projects/SWEEX/slug/i2c/SE95_thermometer_python_i2c.html
###############################

import os
import sys

class Print():
    # Print things to stdout on one line dynamically
    def __init__(self,data):
        sys.stdout.write("\r\x1b[K"+data.__str__())
        sys.stdout.flush()

### HEX Address of the SE95 ###
# uncomment this if you want to set the address as a paramenter
#address = sys.argv[1]
# or set the address fix
address = "0x48"

# write a 0 to the 0 register
os.popen('i2cset -y 0 ' + address + ' 0x00 0x00 b > /dev/null 2>&1')

while True:
  SE95_temp = os.popen('i2cget -y 0 '+ address +' 0x00 w').read()

# get the two hex bytes from the received text string (it is like 0xdc12)
  SE95_byte_HI = SE95_temp[4:6]
  SE95_byte_LO = SE95_temp[2:4]

  SE95_byte_HI_dec = int(SE95_byte_HI , 16)
  SE95_byte_LO_dec = int(SE95_byte_LO , 16)

  sign = 1

# is the temperature negative?
  if SE95_byte_HI_dec >= 128:
    SE95_byte_HI_dec = float(SE95_byte_HI_dec ^ 255) # ^ is XOR
    SE95_byte_LO_dec = float((SE95_byte_LO_dec ^ 255) + 1)
    sign = -1

  SE95_byte_HI_dec = float(SE95_byte_HI_dec)
  SE95_byte_LO_dec = float(SE95_byte_LO_dec)

  temp_all = (SE95_byte_HI_dec + SE95_byte_LO_dec/256)

# round the value to one digit after the dot
  temp_1_dec = round(temp_all, 1)

  if temp_1_dec == 0:
    sign = 1 #or else we see "-1"

  temp_1_dec = sign * temp_1_dec

# print the Temperatur to CLI
  output = "Temperatur: %s " % temp_1_dec
  Print(output)
